import type { RedirectCode, Route, RouteGroupOptions, RouterInterface } from '@stacksjs/types';
export declare class Router implements RouterInterface {
    private routes;
    private apiPrefix;
    private groupPrefix;
    private path;
    private addRoute;
    get(path: Route['url'], callback: Route['callback']): Promise<this>;
    email(path: Route['url']): Promise<this>;
    health(): Promise<this>;
    job(path: Route['url']): Promise<this>;
    action(path: Route['url']): Promise<this>;
    post(path: Route['url'], callback: Route['callback']): this;
    view(path: Route['url'], callback: Route['callback']): this;
    redirect(path: Route['url'], callback: Route['callback'], _status?: RedirectCode): this;
    delete(path: Route['url'], callback: Route['callback']): this;
    patch(path: Route['url'], callback: Route['callback']): this;
    put(path: Route['url'], callback: Route['callback']): this;
    group(options: string | RouteGroupOptions, callback?: () => void): this;
    name(name: string): this;
    middleware(middleware: Route['middleware']): this;
    prefix(prefix: string): this;
    getRoutes(): Promise<Route[]>;
    private setGroupPrefix;
    private prepareGroupPrefix;
    private resolveCallback;
    private importCallbackFromPath;
    private normalizePath;
    prepareUri(path: string): string;
    private updatePathIfNeeded;
}
export declare const route: Router;
